#!/usr/bin/perl                                                                      
# 
# FloodWorld v1.0.a3 (NetBan Perl Module)
# 
# (C)Copyright 2001
# Brian M. King
# All Rights Reserved
#       
# This program is provided as is, without warranty. The author is not liable
# for any and all actions as a result of the code herein.
#
# Special thanks to PreZ for lending me his brain and helping me to make this
# software.
#       
# Also, special thanks to Shrapnal for helping me with beta 
# testing and debugging the software as well as providing
# the criticism and ideas that helps to make this the best
# software there is =)
#       
##############################################################################
# NEWPASS Remote Command
#
# This command is used for root admin's to
# change the password of an operator in the
# database to a new password.
#
# This should really only be used if you are
# using password encryption and one of your
# staff members have lost their password.
#
sub do_newpass {
   @params = split(/ /, shift);
   if (&has_access($params[0]) == 400) {
      if (@params < 3) {
         &notice($params[0], "Syntax: NEWPASS NickName NewPassword");
         return;
      }
      if (!(defined($nicks{lc($params[1])}))) {
         &notice($params[0], "$params[1] not found in database");
         return;
      }
      if (lc($config{'EncryptPass'}) eq "yes") {
         $N_TempPass = &encrypt($params[2]);
      } else {
         $N_TempPass = $params[2];
      }
      $nicks{lc($params[1])}->{Pass} = $N_TempPass;
      &write_ops;
      &load_all;
      &notice($params[0], "Password for $params[1] successfully changed.");
      &globops("$params[0] did NEWPASS on $params[1]");
      &logit("$params[0] did NEWPASS on $params[1]");
   } else {
      &notice($params[0], "Access denied");
      &globops("$params[0] failed NEWPASS (No access/ident)");
      &logit("$params[0] failed NEWPASS");
   }
}
###############
# JUPENICK Remote Command
#
# Log's a pseudo client onto the network that
# will use the nickname of the specified nick
# for whatever reason the oper chooses to set
# the jupe.
#
# Syntax: JUPENICK NickName
sub do_jupenick {
   @params = split(/ /, shift);
   if (&has_access($params[0]) >= 200) {
      if (!($params[1])) {
         &notice($params[0],"Syntax: JUPENICK NickName");
         return;
      }
      if ($params[1] =~ /\./) {
         &notice($params[0], "Sorry but you cannot use this command to jupe servers.");
         return;
      }
      if (defined($nicks{lc($params[1])})) {
         &KillUser($sock, $params[1], "Juped");
      }
      &IntroduceUser($sock, $params[1], "juped.floodworld.relic.net");
      &globops("$params[0] did JUPENICK on $params[1]");
      &logit("$params[0] did JUPENICK on $params[1]");
   } else {
      &notice($params[0], "Access denied");
      &globops("$params[0] failed JUPENICK (No access/ident)");
      &logit("$params[0] failed to JUPENICK $params[1]");
   }
}
###############
# Used in correspondence with the following
# sub routine. 
#
# Essentially this just loads a pseudo server
# onto the network in place of the real thing.
#
sub JupeServerString {
   $SSock = shift;
   $SSName = shift;
   $SSWho = shift;
   $SSWhy = shift;
   $JString = "Juped by $SSWho for - $SSWhy";
   $TimeStamp = time();
   $SString = $protocol{'ServerString'};
   $SString =~ s/<SN>/$SSName/g;
   $SString =~ s/<SD>/$JString/g;
   $SString =~ s/<TM>/$TimeStamp/g;
   print $SSock $SString . "\n";
   if (($DebugMode == 2) || ($Debug == 1)) {
      &logdebug("--> $SString");
   }
   undef($SSock);
   undef($SString);
}
###############
# JUPE Remote Command
#
# Load's a pseudo server onto the network in
# place of the real one for whatever the specified
# reason.
#
# Syntax: JUPE server.name.net Reason
sub do_jupeserver {
   @params = split(/ /, shift);
   $J_Who  = shift(@params);
   $J_What = shift(@params);
   $J_Why  = join(" ", @params);

   if (&has_access($J_Who) >= 300) {
      if ((!($J_What =~ /\./)) || (!($J_Why))) {
         &notice($J_Who, "Syntax: JUPESERVER Server.Name.Here Reason for Jupiter");
         return;
      }
      &JupeServerString($sock, $J_What, $J_Who, $J_Why);
      &globops("$J_Who did JUPESERVER on $J_What for -- $J_Why");
      &logit("$J_Who jupitered $J_What -- $J_Why");
   } else {
      &notice($J_Who,"Access denied");
      &globops("$J_Who failed JUPESERVER on $J_What (No access/ident)");
      &logit("$J_Who failed to JUPESERVER $J_What for -- $J_Why");
   }
}
###############
# Setmode Remote Command
#
# Added to make life easier for networks that either have
# crappy services or services without a setmode command.
#
# This basically enables an oper to set a certain mode on
# a certain channel on the specified user(s) or just on the
# channel itself. Great for when services are lagged or not
# connected.
#
# Syntax: SETMODE #Channel +<mode(s)> {User(s)}
#
sub do_setmode {
   @params = split(/ /, shift);
   $UNick = $params[0];
   $ULevel = &has_access($params[0]);
   $What = $params[1];
   splice(@params,0,2);
   $Rest = join(" ", @params);
   if ($ULevel >= 100) {
      print $sock ":$MyClientName MODE $What $Rest\n";
      &globops("$UNick did SETMODE ($What $Rest)");
      &logit("$UNick did SETMODE ($What $Rest)");
   } else {
      &notice($UNick,"Access Denied");
      &globops("$UNick failed SETMODE (No access/ident)");
   }
}
###############
# NetBan Remote Command
#
# This is used on networks that have the ability to have
# the service set its own netbans and enables opers to
# set a ban on a host. Basically this is a substitute for
# your operservice in the event that it may be down.
#
# Syntax: NETBAN {ADD|DEL} Host +expiry Reason
#
# IE: /msg FloodWorld netban add *@foo.bar.com +2d You suck!
#
# Bans the host *@foo.bar.com from the network for 2 days with
# the reason "You suck!" .. This is really only useful if your
# ircd supports GLINE and you has changed the $protocol{'RemoveUser'}
# string to match the string needed to set a GLINE on your network.
#
# NOTE: This will NOT work if you are making FloodWorld use your
#       oper service to set bans.
sub do_netban {
   @params = split(/ /, shift);
   $ULevel = &has_access($params[0]);
   $UNick = $params[0];
   $GTime = &determine_netban_time($params[3]);
   $GHost = $params[2];
   if ($ULevel >= 100) {
      if (lc($params[1]) eq "add") {
         if ($GTime == 0) {
            &notice($UNick,"Syntax: NETBAN {ADD|DEL} Host +Expiry Reason");
            return;
         }
         if ((!($params[2])) || (!($params[3])) || (!($params[4]))) {
            &notice($UNick,"Syntax: NETBAN {ADD|DEL} Host +Expiry Reason");
            return;
         }
         if ($ULevel == 100) {
            if ($GTime > 172800) {
               &notice($UNick,"Sorry, but at your level you cannot go above +2d");
               return;
            }
         } elsif ($ULevel == 200) {
            if ($GTime > 864000) {
               &notice($UNick,"Sorry, but at your level you cannot go above +10d");
               return;
            }
         } elsif ($ULevel == 300) {
            if ($GTime > 2592000) {
               &notice($UNick,"Sorry, but at your level you cannot go above +30d");
               return;
            }
         }
         splice(@params,0,4);
         $GReason = join(" ",@params);
         print $sock ":$MyServerName GLINE $GTime +$GHost $GTime :$GReason\n";
         print $sock ":$MyClientName PRIVMSG $DebugChannel :$UNick did NETBAN on $GHost\n";
         print $sock ":$MyClientName PRIVMSG $DebugChannel ::$MyServerName GLINE $GTime +$GHost $GTime :$GReason\n";
         
         &globops("$UNick set a netban on ($GHost) at (" . &duration($GTime) . ") for ($GReason)");
         &logit("$UNick did NETBAN on $GHost ($GTime) for ($GReason)");
      } elsif (lc($params[1]) eq "del") {
         print $sock ":$MyServerName GLINE $GTime -$GHost\n";
         print $sock ":$MyClientName PRIVMSG $DebugChannel :$UNick removing NETBAN on $GHost\n";
         print $sock ":$MyClientName PRIVMSG $DebugChannel ::$MyServerName GLINE $GTime -$GHost\n";
         
         &globops("$UNick removing netban on ($GHost)");
         &logit("$UNick removed NETBAN on $GHost");
      } else {
         &notice($UNick,"Unknown parameter -- $params[1]");
      }
   } else {
      &notice($UNick,"Access denied");
      &globops("$UNick failed NETBAN (No access/ident)");
   }
}
###############
# Used in correspondence with the NETBAN command ..
#
# Basically this takes a specified expiry and turns it
# into seconds .. IE: +1h becomes 3600, +10m becomes 600
# and so on.
#
sub determine_netban_time {
   $TempTime = shift;

   if (!($TempTime =~ /\+/)) {
      return 0;
   }
   if (!($TempTime =~ /[d,h,m]/)) {
      return 0;
   }
   $TempTime =~ s/\+//g;
   if ($TempTime =~ /d/) {
      $TempTime =~ s/d//g;
      $RetTime = (86400 * $TempTime);
      return $RetTime;
   } elsif ($TempTime =~ /h/) {
      $TempTime =~ s/h//g;
      $RetTime = (3600 * $TempTime);
      return $RetTime;
   } elsif ($TempTime =~ /m/) {
      $TempTime =~ s/h//g;
      $RetTime = (60 * $TempTime);
      return $RetTime;
   }
}
# !!! DO NOT REMOVE THE FOLLOWING LINE OR I WILL NOT WORK !!!
1
