#!/usr/bin/perl
#
# FloodWorld v1.0.a3 (Configuration Perl Module)
#
# (C)Copyright 2001
# Brian M. King
# All Rights Reserved
#
# This program is provided as is, without warranty. The author is not liable
# for any and all actions as a result of the code herein.
#
# Special thanks to PreZ for lending me his brain and helping me to make this
# software.
#
# Also, special thanks to Shrapnal for helping me with beta
# testing and debugging the software as well as providing
# the criticism and ideas that helps to make this the best
# software there is =)
#
# NOTE: Extensive explainations of all objects in this module are
#       explained in the README file. If you have not already read
#       the README then I urge you to do so before you continue 
#       using this service. I will not assist anyone with any 
#       questions reguarding this service until you have first 
#       read the README and have attempted to do that which you
#       need help with first.
#
# NOTE: Aparently some people are having trouble following the
#       pattern that I used in here with the commands and the
#       white spacing. Make sure that any values that start
#       with a quotation mark, end with a quotation mark and
#       make sure none of the comments on the lines carry onto
#       the next line without first starting with a pound 
#       sign (#) otherwise it will be interpreted as code and
#       thus you will get an error.
#
$RemoteServer        = "111.111.111.111";            # Remote Server to link too
$RemotePort          = 8888;                         # Remote Port to link too
$MyServerName        = "floodworld.yournet.net";     # Server Name I will use
$MyLinkPass          = "LinkPass";                   # Link Pass to remote server
$MyServerDescription = "Network flood protection";   # Server Description
$MyClientName        = "FloodWorld";                 # Main Client Name
$MyClientHost        = "yournet.net";                # Main Client Host
$MyClientVHost       = "yournet.net";                # Main Client Vanity Host
$MyClientDescription = "Network flood protection";   # Main Client Realname
$MyClientUmodes      = "z";                          # Main Client Usermodes
$MyNickPass          = "SomePassHere";               # Main Client Nick Pass
$GhostNick           = "GhostNick";                  # Ghost Client Nickname
$GhostHost           = "some.host.com";              # Ghost Client Host 
$GhostVHost          = "some.host.com";              # Ghost Client Vanity Host
$GhostDescription    = "blah";                       # Ghost Client Realname
$GhostUmodes         = "i";                          # Ghost Client Usermodes
$UseDebug            = 1;                            # Use debugging while online
$DebugChannel        = "#Debug";                     # Debug channel for debug messages
$UserDatabase        = "users.db";                   # Users Database
$ChannelsDatabase    = "chans.db";                   # Channels Database
$PIDFile             = "fworld.pid";                 # Program Identification File

$NickServiceNick     = "NickServ";                   # Your Nick Service NickName
$NickServiceHost     = "relic.net";                  # Your Nick Service Host
$NickServiceKeyWord  = "IDENTIFY";                   # Needed to determine to IDENTIFY or not

$UseNickService      = 0;                            # 1 Yes, 0 No -- Do I IDENTIFY ?

$HelpHost            = "help\@relic.net";            # Email Contact inserted in Ban Messages

$OperService         = "OperServ";                   # Name of your oper service.

$UseKill             = 1;                            # Kill user for flooding?
                                                     # Nice to have when your oper service
                                                     # is lagging. 1 = Yes, 0 = No

###############
# This is use in conjunction with the above
# option. If the above option is set to 1
# then we will use this string to kill a user
# from the network AFTER we send the gline/akill
# command through. This is useful if your oper
# service is lagged.
#
# <NN> = NickName
# <CN> = Client NickName (Person to kill)
# <PATH> = Some ircd's require this
# <R> = Reason
$protocol{'KillUser'} = ":<NN> KILL <CN> :<PATH> (<R>)";

###############
# Ok, I removed this string from the protocol.pm and put it 
# in here because alot of people were saying that they 
# shouldnt have to go through and find the protocol they 
# are using in protocol.pm and change this string to suit
# their needs so instead I put it in here in the hopes that
# people will be able to configure it alot easier and be
# able to change this without having to message me a few
# hundred times to get help. 
#
# Example 1: (Using RelicNet's RWorld)
#    $protocol{'RemoveUser'} = ":<NN> NOTICE $OperService :FGLINE <RU> <R>";
#
# Example 2: (Using OperServ)
#    $protocol{'RemoveUser'} = ":<NN> PRIVMSG $OperService :AKILL ADD <RU> +2h <R>";
#
#    This is assuming that your OperServ takes a time-specification parameter
#    to indicate how long to leave the person AKilled for. The +2h means
#    akill them for two hours. If your OperService uses a different AKILL 
#    format then you must change the below like to suit the different. 
#
# By default I am leaving this as the syntax used on RelicNet to gline
# users. If you are running a different OperService (Which I imagine you are)
# you must change this to the exact syntax that is needed to send the 
# akill/gline/whatever to your OperService. See the examples above. If 
# you do not understand the flags, <RU>, <R>, etc. Please read the comments
# in the protocol.pm file. They are all explained there.
#
# As mentioned this is the default for RelicNet but if you wish to use the
# other format where it uses your oper service then comment the following
# line out with the pound sign (#) and uncomment the next line.
#
$protocol{'RemoveUser'} = ":<SN> GLINE 7200 +<RU> 7200 :<R>";
#
# Uncomment the following line and comment out the above line to
# use your oper service instead of it setting its own GLINEs. This
# defaults to sending an akill command to the oper service with
# the reason, the parameter for a 2 hour ban, and the reason. You
# may change this to suit whatever the needs of your network.
#
#$protocol{'RemoveUser'} = ":<NN> PRIVMSG $OperService :AKILL <RU> +2h <R>";

###############
# High ASCII Character Code Numbers
# that are used in mIRC for all those
# annoying colors and bold and so on.
# These are used in the main source
# code to remove all mIRC color codes
# and so fourth from all text received
# from the remote host.
$Bold      = chr(2);
$UnderLine = chr(31);
$Reverse   = chr(22);
$Color     = chr(3);
$Regular   = chr(15);
$CTCPChar  = chr(1);

###############
# Remote Command names and their 
# corresponding sub routines.
#
# The reason it is done this way
# is so that any commands can be
# added here as well as the sub
# routine in which handles all the
# needed parameters without having
# to change a ton of code.
#
# All sub routines for all remote 
# commands receive the same initial
# parameters. They always received
# the NICKNAME of the person that did
# the command followed by any parameters
# that the sub routine will need. These
# are all delimited by a space and so
# every remote command sub routine uses
# an array called 'params' that contains
# each word (parameter) that was space
# delimited from what was sent to that
# sub routine.
%commands = ('addchan'   , 'do_addchan',
             'delchan'   , 'do_delchan',
             'addop'     , 'do_addop',
             'delop'     , 'do_delop',
             'identify'  , 'do_identify',
             'setpass'   , 'do_setpass',
             'textflood' , 'do_textflood',
             'ctcpflood' , 'do_ctcpflood',
             'joinflood' , 'do_joinflood',
             'listadmin' , 'do_listadmin',
             'listchans' , 'do_listchans',
             'help'      , 'do_help',
             'shutdown'  , 'do_shutdown',
             'status'    , 'do_status',
             'grname'    , 'do_grname',
             'chlevel'   , 'do_chlevel',
             'rehash'    , 'do_rehash',
             'forbid'    , 'do_forbid',
             'info'      , 'do_info',
             'deltext'   , 'do_deltext',
             'cjoinall'  , 'do_cjoinall',
             'aflood'    , 'do_aflood',
             'nickflood' , 'do_nickflood',
             'joinflood' , 'do_joinflood',
             'ghosthost' , 'do_ghosthost',
             'netban'    , 'do_netban',
             'nflood'    , 'do_nflood',
             'setmode'   , 'do_setmode',
             'jupeserver', 'do_jupeserver',
             'jupenick'  , 'do_jupenick',
             'newpass'   , 'do_newpass');

###############
# This array contains all the CTCP Types
# that this service should look for while
# the CTCP Flood Protection is active. Feel
# free to add any types that I may have 
# missed.
#
# Each is searched for by the CTCP High 
# ASCII char (chr(1)) and one of these
# elements in order for it to trigger
# the protection at all. The reason for
# this is because DCC and ACTION both
# also use chr(1) as their High ASCII
# character (Unfortunately).
@CTCPTypes = ("PING",
              "VERSION",
              "TIME",
              "FINGER",
              "USERINFO",
              "CLIENTINFO",
              "PAGE");

# DO NOT REMOVE THE BELOW LINE !!! IF YOU DO I WONT WORK
1
